﻿using NUnit.Framework;
using Tile16_Decoupled;

namespace Test_Tile16_Decoupled
{
    [TestFixture]
    public class TestTiles
    {
        [Test]
        public void CreateTileWithValue()
        {
            Assert.That(new Tile().GetValue(), Is.EqualTo(1));
            Assert.That(new Tile(5).GetValue(), Is.EqualTo(5));
        }

        [Test]
        public void CreateTileWithInvalidValue()
        {
            Assert.Throws<InvalidTileValueException>(()=>new Tile(-1));
        }

        [Test]
        public void TestTileEquality()
        {
            Assert.That(new Tile(), Is.EqualTo(new Tile()));
            Assert.That(new Tile(1), Is.EqualTo(new Tile(1)));
            Assert.That(new Tile(1), Is.Not.EqualTo(new Tile(2)));
        }

        [Test]
        public void TestTileAddition()
        {
            Assert.That(new Tile().Plus(new Tile(2)), Is.EqualTo(new Tile(3)));
            Assert.That(new Tile(2).Plus(new Tile(2)), Is.EqualTo(new Tile(4)));
        }
    }

    
}