﻿using Tile16_Decoupled;
using Tile16_Unity_Testable;
using UnityEngine;

public class BoardUpdaterBehavior : MonoBehaviour {

    public GameObject tileGO;
    public Board GameBoard;

    private TileCreatorBehaviorMediator tileCreatorMediatorMediator;
    private TileCreator tileCreator;
    private GameObject curTile;
    // Use this for initialization
    void Start ()
    {
        tileCreatorMediatorMediator = new TileCreatorBehaviorMediator(GameBoard);
        tileCreator = new TileCreator(tileCreatorMediatorMediator); 
    }

    public void UpdateBoard()
    {
        var tileList = GameBoard.PopNewlyCreatedTiles();
        foreach (var tilePair in tileList)
        {
            tileCreatorMediatorMediator.SetNewTile(Instantiate(tileGO));
            tileCreator.Create(tilePair.Key, tilePair.Value);
        }
    }
}
