﻿using Tile16_Unity_Testable;
using UnityEngine;

public class GameControllerBehaviorMediator : GameControllerMediator
{
    private BoardUpdaterBehavior boardUpdater;

    private MonoBehaviour unityGameController;
    //private AudioSource sfxLoop;
    private AudioSource sfxNextWave;
    private AudioSource sfxWin;
    private AudioSource sfxLose;
    private GameObject winSequence;
    private GameObject loseSequence;

    public GameControllerBehaviorMediator(MonoBehaviour unityGameController)
    {
        this.unityGameController = unityGameController;
    }

    public void SetWinSequence(GameObject winSequence)
    {
        this.winSequence = winSequence;
    }

    public void SetLoseSequence(GameObject loseSequence)
    {
        this.loseSequence = loseSequence;
    }

    public void SetBoardUpdater(BoardUpdaterBehavior boardUpdater)
    {
        this.boardUpdater = boardUpdater;
    }

    public void Initialize()
    {
        var soundSources = unityGameController.GetComponents<AudioSource>();
        //sfxLoop = soundSources[0];
        sfxNextWave = soundSources[1];
        sfxWin = soundSources[2];
        sfxLose = soundSources[3];
        //sfxLoop.Play();
    }

    public void UpdateBoard()
    {
        boardUpdater.UpdateBoard();
    }

    public void PlayNextWaveSfx()
    {
        sfxNextWave.Play();
    }

    public void PlayWinSfx()
    {
        sfxWin.Play();
    }

    public void PlayLoseSfx()
    {
        sfxLose.Play();
    }

    public void EnableWinAnimation()
    {
        winSequence.SetActive(true);
    }

    public void EnableLoseAnimation()
    {
        loseSequence.SetActive(true);
    }

    public void DisableWinAnimation()
    {
        winSequence.SetActive(false);
    }

    public void DisableLoseAnimation()
    {
        loseSequence.SetActive(false);
    }

    public float GetDeltaTime()
    {
        return Time.deltaTime;
    }
}