using Tile16_Decoupled;
using Tile16_Unity_Testable;
using UnityEngine;

public class TileCreatorBehaviorMediator : TileCreatorMediator
{
    private GameObject newTile;
    private SpriteRenderer spriteRenderer;
    private TileControllerBehavior tileController;
    private TextMesh textMesh;
    

    //private Board board;

    public TileCreatorBehaviorMediator(Board board)
    {
        //this.board = board;
    }

    public float GetTileWidth()
    {
        return spriteRenderer.bounds.size.x / newTile.transform.localScale.x;
    }

    public Vector2 GetGridLowerLeftCorner()
    {
        return GameConstants.gridLowerLeftCorner;
    }

    public void InstantiateTile()
    {
        spriteRenderer = newTile.GetComponent<SpriteRenderer>();
        tileController = newTile.GetComponent<TileControllerBehavior>();
        textMesh = newTile.transform.GetChild(0).gameObject.GetComponent<TextMesh>();
    }

    public void AddTileToTileControllerDictionary(Tile tile, Point pos)
    {   
        tileController.InitTile(tile, pos);
    }

    public void SetNewTile(GameObject newTile)
    {
        this.newTile = newTile;
    }

    public void SetValueText(string valueText)
    {
        textMesh.text = valueText;
    }

    public void SetTilePosition(Vector2 position)
    {
        newTile.transform.position = position;
    }

    public void SetTileColor(Color32 tileColor)
    {
        spriteRenderer.color = tileColor;
    }
}