﻿using System;

namespace Tile16_Decoupled
{
    public struct Point
    {
        public Point(int x, int y)
        {
            if (x > short.MaxValue || x < short.MinValue || y > short.MaxValue || y < short.MinValue)
                throw new PointTooLargeException();
            X = (short) x;
            Y = (short) y;
        }

        public Point(short x, short y)
        {
            X = x;
            Y = y;
        }

        public readonly short X;
        public readonly short Y;

        public override bool Equals(object obj)
        {   
            Point point = (Point) obj;
            return point.X == X && point.Y == Y;
        }

        public override int GetHashCode()
        {
            int hash = Y;
            hash <<= 16;
            hash |= (int)X;
            return hash;
        }

        public override string ToString()
        {
            return X.ToString() + "," + Y.ToString();
        }
    }

    public class PointTooLargeException : Exception
    {
    }
}