﻿using System;

namespace Tile16_Decoupled
{
    public class InvalidTileValueException : Exception { }
    
    public class Tile
    {
        private readonly int value;

        public Tile(int value)
        {
            AssertValidTileValue(value);
            this.value = value;
        }

        private static void AssertValidTileValue(int value)
        {
            if (value < 1)
                throw new InvalidTileValueException();
        }

        public Tile()
        {
            value = 1;
        }

        public int GetValue()
        {
            return value;
        }

        public override bool Equals(object obj)
        {
            Tile tile = (Tile) obj;
            return tile.GetValue() == value;
        }

        public Tile Plus(Tile tile)
        {
            return new Tile(tile.GetValue() + value);
        }

        public override int GetHashCode()
        {
            return value;
        }

        public override string ToString()
        {
            return value.ToString();
        }
    }
}