﻿using System;
using System.Security.Policy;

namespace Tile16_Decoupled
{
    public class WinConditions : IWinConditions
    {
        public bool GameWon { get; private set; }
        public bool GameOver { get; private set; }
        private int winningTileValue = 1;
        private Board board;

        public int WinningTileValue
        {
            get { return winningTileValue; }

            set
            {
                if (value < 1)
                    throw new InvalidWinningTileValueException();
                winningTileValue = value;
            }
        }

        public void SetBoard(Board board)
        {
            this.board = board;
        }

        public void Reset()
        {
            GameWon = false;
            GameOver = false;
        }

        public void UpdateStatusByBiggestTileValue()
        {
            IsGameWon();
            if (board.IsFull())
                GameOver = true;
            
        }

        public bool NotWinningButNotGameOver()
        {
            //UpdateStatusByBiggestTileValue();
            return !GameWon && !GameOver;
        }

        public bool IsGameWon()
        {
            if (board.GetBiggestTileValue() == winningTileValue)
            {
                GameOver = true;
                return GameWon = true;
            }
            return false;
        }

        public bool GameOverButDidntWin()
        {
            return GameOver && !GameWon;
        }
    }

    public class InvalidWinningTileValueException : Exception
    {
    }
}