﻿using UnityEngine;

namespace Tile16_Unity_Testable
{
    public interface TileControllerMediator
    {
        //Transform
        Vector2 GetPosition();
        void SetPosition(Vector2 vector2);
        float GetScaleX();

        //Renderer
        float GetBoundSizeX();
        void SetRendererInactive();
        //Inputs - not apart of the interface, but should be implemented in the subclasses

        //Sound and Animation
        void PlayPickUpAnimation();
        void PlayPickUpSfx();
        void PlayDropSfx();
        void PlayDropAnimation();
        void PlayCombineSfx();
        void PlaySpawnAnimation();

        //Collider
        void SetColliderSize(Vector2 vector2);

        //RigidBody
        Vector2 GetVelocity();
        void SetVelocity(Vector2 velocity);
        void KinematicUnset();
        void KinematicSet();
        
        //Logics
        void UpdateBoard();
        void DestroyCollisionObjects();
        void DestroySelf();
    }
}