﻿using System.Collections.Generic;
using Tile16_Decoupled;
using UnityEngine;

namespace Tile16_Unity_Testable
{
    public class TileCreator
    {
        private TileCreatorMediator tcm;
        private List<Color32> colorList;

        public TileCreator(TileCreatorMediator tcm)
        {
            this.tcm = tcm;
            InitColorList();
        }

        private void InitColorList()
        {
            colorList = new List<Color32>()
            {
                new Color32(220, 20, 60, 255), //crimson
                new Color32(218, 112, 214, 225), //orchid
                new Color32(75, 0, 130, 255), //indigo
                new Color32(131, 111, 255, 255), //slateblue
                new Color32(61, 89, 171, 255), //cobalt
                new Color32(70, 130, 180, 255), //steelblue
                new Color32(0, 245, 255, 255), //turquoise
                new Color32(0, 128, 128, 255), //teal
                new Color32(0, 255, 127, 255), //springgreen
                new Color32(34, 139, 34, 255), //forest green
                new Color32(107, 142, 35, 255), //olivedrab
                new Color32(128, 128, 0, 255), //olive
                new Color32(218, 165, 32, 255), //goldenrod
                new Color32(156, 102, 31, 255), //brick
                new Color32(94, 38, 18, 255), //sepia
                new Color32(178, 34, 34, 255), //crimson
            };
        }

        public void Create(Point pos, Tile tile)
        {
            tcm.InstantiateTile();
            var tileWidth = tcm.GetTileWidth();
            var centerPos = tileWidth/2;
            var position = new Vector2(pos.X * tileWidth + centerPos, pos.Y * tileWidth + centerPos) +
                       tcm.GetGridLowerLeftCorner();
            var valueText = tile.GetValue().ToString();
            var tileColor = colorList[(tile.GetValue() - 1) % 16];

            tcm.SetValueText(valueText);
            tcm.SetTilePosition(position);
            tcm.SetTileColor(tileColor);
            tcm.AddTileToTileControllerDictionary(tile, pos);
        }


    }
}