﻿using Tile16_Decoupled;
using UnityEngine;

namespace Tile16_Unity_Testable
{
    public class TileSnappingGrid
    {
        private float tileWidth;
        private int xTiles;
        private int yTiles;
        private float gridWidth;
        private float gridLength;

        public void SetTileSideLength(float width)
        {
            this.tileWidth = width;
        }

        public void InitializeGridWithDimensions(int xTiles, int yTiles)
        {
            this.xTiles = xTiles;
            this.yTiles = yTiles;
            this.gridWidth = xTiles*tileWidth;
            this.gridLength = yTiles*tileWidth;
        }


        public float GetWidth()
        {
            return gridWidth;
        }

        public float GetLength()
        {   
            return gridLength;
        }

        public Vector2 GetSnappingPosition(Vector2 pos)
        {
            if (OutOfBound(pos))
                return pos;
            float nearestX = ((int) (pos.x/tileWidth))*tileWidth;
            float nearestY = ((int)(pos.y / tileWidth)) * tileWidth;
            return new Vector2(nearestX+tileWidth/2, nearestY+tileWidth/2);

        }

        private bool OutOfBound(Vector2 pos)
        {
            return (pos.x < 0 || pos.y < 0) || (pos.x > gridWidth - 0.0001 || pos.y > gridLength - 0.0001);
        }

        public Point GetSnappingPoint(Vector3 pos)
        {   
            return new Point((int)(pos.x / tileWidth), (int)(pos.y / tileWidth));
        }
    }
}
